#include "qtleds.h"
#include "ui_qtleds.h"
#include <fcntl.h>
#include <sys/ioctl.h>
#include <QMessageBox>

qtLeds::qtLeds(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::qtLeds)
{
    ui->setupUi(this);
    ui->checkBoxLed0->setEnabled(false);
    ui->checkBoxLed1->setEnabled(false);
    ui->checkBoxLed2->setEnabled(false);
    ui->checkBoxLed3->setEnabled(false);
#if defined(Q_WS_QWS)
    leds_fd = ::open("/dev/leds0", 0);
    if (leds_fd < 0) {
		leds_fd = ::open("/dev/leds", 0);
    }
    if (leds_fd < 0) {
        QMessageBox::warning(0,
                             "qtLeds",
                             "Can't open device leds");
    }
#endif
}

qtLeds::~qtLeds()
{
	::close(leds_fd);
    delete ui;
}

void qtLeds::on_pushButtonLedPlayer_toggled(bool checked)
{
    if(checked){
#if defined(Q_WS_QWS)
        system("/etc/rc.d/init.d/leds stop");
#endif
        ui->pushButtonLedPlayer->setText("Start led counter");
        vResetLeds();
    }else{
#if defined(Q_WS_QWS)
        system("/etc/rc.d/init.d/leds start");
#endif
        ui->pushButtonLedPlayer->setText("Stop led counter");
    }
}

void qtLeds::on_checkBoxLed0_toggled(bool checked){
    if(checked){
 #if defined(Q_WS_QWS)
        ::ioctl(leds_fd, 1, 0);
 #endif
    }else{
 #if defined(Q_WS_QWS)
        ::ioctl(leds_fd, 0, 0);
#endif
    }
}

void qtLeds::on_checkBoxLed1_toggled(bool checked)
{
    if(checked){
#if defined(Q_WS_QWS)
        ::ioctl(leds_fd, 1, 1);
#endif
    }else{
#if defined(Q_WS_QWS)
        ::ioctl(leds_fd, 0, 1);
#endif
    }
}


void qtLeds::on_checkBoxLed2_toggled(bool checked)
{
    if(checked){
#if defined(Q_WS_QWS)
        ::ioctl(leds_fd, 1, 2);
#endif
    }else{
#if defined(Q_WS_QWS)
        ::ioctl(leds_fd, 0, 2);
#endif
    }
}

void qtLeds::on_checkBoxLed3_toggled(bool checked)
{
    if(checked){
#if defined(Q_WS_QWS)
        ::ioctl(leds_fd, 1, 3);
#endif
    }else{
#if defined(Q_WS_QWS)
        ::ioctl(leds_fd, 0, 3);
#endif
    }
}

void qtLeds::vResetLeds(){
    for(int i = 0 ; i < 4 ; i++){
#if defined(Q_WS_QWS)
        ::ioctl(leds_fd, 0, i);       
#endif
    }
    ui->checkBoxLed0->setChecked(false);
    ui->checkBoxLed1->setChecked(false);
    ui->checkBoxLed2->setChecked(false);
    ui->checkBoxLed3->setChecked(false);
}
